""" All the infrastructure code related to adding hooks to the code generation process """


_hooks = {}


def register_hook(hookname, func):
    current = _hooks.setdefault(hookname, ())
    current = list(current)
    current.append(func)
    _hooks[hookname] = tuple(current)


def run_hook(hookname, *args, **kwargs):
    for hook in _hooks[hookname]:
        hook(*args, **kwargs)
